uniform lowp vec3 outlineColor;
uniform mediump float opacity;
varying mediump vec2 vTex;
uniform mediump vec2 pixelSize;
uniform lowp sampler2D samplerFront;
precision mediump float;


void main(void)
{
    vec2 size = pixelSize;
    float outline = texture2D(samplerFront, vTex + vec2(-size.x, 0.0)).a;
	outline += texture2D(samplerFront, vTex + vec2(0.0, size.y)).a;
	outline += texture2D(samplerFront, vTex + vec2(size.x, 0.0)).a;
	outline += texture2D(samplerFront, vTex + vec2(0.0, -size.y)).a;
	outline = min(outline, 1.0);
	
	vec4 front = texture2D(samplerFront, vTex);

    gl_FragColor = outline - front.a > .5 ? vec4(outlineColor, opacity): front;
}