﻿%%FRAGMENTINPUT_STRUCT%%

%%FRAGMENTOUTPUT_STRUCT%%

%%SAMPLERFRONT_BINDING%% var samplerFront : sampler;
%%TEXTUREFRONT_BINDING%% var textureFront : texture_2d<f32>;

struct ShaderParams {
	outlineColor : vec3<f32>,
	opacity : f32
	
};
%%SHADERPARAMS_BINDING%% var<uniform> shaderParams : ShaderParams;

%%C3PARAMS_STRUCT%%

%%C3_UTILITY_FUNCTIONS%%

@fragment
fn main(input : FragmentInput) -> FragmentOutput
{
	let size: vec2<f32> = c3_getPixelSize(textureFront);

	var outline: f32 = textureSample(textureFront, samplerFront, input.fragUV + vec2<f32>(-size.x, 0.0)).a;
	outline += textureSample(textureFront, samplerFront, input.fragUV + vec2<f32>(0.0, size.y)).a;
	outline += textureSample(textureFront, samplerFront, input.fragUV + vec2<f32>(size.x, 0.0)).a;
	outline += textureSample(textureFront, samplerFront, input.fragUV + vec2<f32>( 0.0, -size.y)).a;
	outline = min(outline, 1.);

	let front: vec4<f32> = textureSample(textureFront, samplerFront, input.fragUV);

	var output : FragmentOutput;
	output.color = select(front, vec4<f32>(shaderParams.outlineColor, shaderParams.opacity), outline - front.a > .5 ); 
	return output;
}
